import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Iterator;


public class Miprobe {
	
	// De Reflection

	static long inicio;
	static long nr_peticiones = 0;
	static ArrayList<Long> lista_tiempos = new ArrayList<Long>();
	static final long NR_PETICIONES_FICHERO = 20;

	static Object reloj = null;
	static Method getThreadTimeMs;

	static
	{
		try
		{
			/* Use reflection to get the required classes */
			ClassLoader myClassLoader = ClassLoader.getSystemClassLoader();
			
			// Cargamos la clase manualmente
			Class<?> mideTiempos = myClassLoader.loadClass("clocknative.MideTiempos");
			
			// Instanciamos un objeto
			reloj = mideTiempos.newInstance();

			// Obtenemos un metodo
			Class<?>[] parametros_de_llamada = null; // No tiene parametros
			getThreadTimeMs = mideTiempos.getMethod("get_thread_time_ms", parametros_de_llamada);
			
		} catch (Exception e)
		{
			System.err.println("An exception has occured: " + e.getMessage());
			e.printStackTrace();
		}
	}
	
	void entry0()
	{
		/* Make sure our object is not NULL before continuing */
		try {
			inicio = (Long) getThreadTimeMs.invoke(reloj, (Object []) null);
		} catch (Exception e) {
			System.err.println("An exception has occured: " + e.getMessage());
			e.printStackTrace();
		}				

	}
	
	void exit0()
	{
		long fin = 0;
		try
		{
			fin  = (Long) getThreadTimeMs.invoke(reloj, (Object []) null);
		}
		catch (Exception e)
		{
			System.err.println("An exception has occured: " + e.getMessage());
			e.printStackTrace();

		}


		long intervalo = fin -inicio;
		System.out.println("Intervalo: " + intervalo);
		lista_tiempos.add(intervalo);
		nr_peticiones++;

		// Cada 20 peticiones sacamos un fichero
		if (nr_peticiones % NR_PETICIONES_FICHERO == 0)
		{
			FileOutputStream fout = null;

			try
			{
				String filename = "stats" + nr_peticiones + ".csv";

				// Open an output stream
				fout = new FileOutputStream (filename);

				// Print a line of text
				Iterator<Long> indice = lista_tiempos.iterator();

				while (indice.hasNext() )
				{
					new PrintStream(fout).println (indice.next());
				}

				// Close our output stream
				fout.close();		
			}
			// Catches any error conditions
			catch (IOException e)
			{
				System.err.println ("Unable to write to file");
				System.exit(-1);
			}

			lista_tiempos.clear();

		}
	}

	
	public static void main(String args[])
	{
		Miprobe yo_mismo = new Miprobe();
		yo_mismo.entry0();
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		yo_mismo.exit0();
		
	}
}
