package cargasintetica;

import java.io.IOException;
import java.util.HashMap;

public class Carga {
	
	
	private boolean calibrado = false;
	
//	private boolean calibracion_hardcoded = false;
//	private long cuentas_por_ms = 0;
	private final long CUENTAS_POR_MS_PORTATIL_MIGUEL = 635;
	private final long CUENTAS_POR_MS_PC_NUEVO_LABORATORIO = 844;


	private boolean calibracion_hardcoded = true;
	private long cuentas_por_ms = CUENTAS_POR_MS_PORTATIL_MIGUEL;

	/**
	 * 
	 * @param force:  Forzar el calibrado aunque tengamos un valor hardcoded
	 * @param interactivo:  Sacar informacion por consola
	 **/
	public long calibra(boolean force, boolean interactivo)
	{
		long cuentas_de_calibracion = 10000000;
//		long cuentas_de_calibracion = 10000;
		long tiempo_inicial_ms;
		long tiempo_final_ms;
		long intervalo_ms;
		
		
		if ( !force && calibracion_hardcoded)
		{
			// Cuentas por segundo ya estan hechas
			calibrado = true;
			return cuentas_por_ms;
		}
		
		if (interactivo)
		{
			System.out.println("Voy a calibrar, por favor subidme la prioridad y pulsar ENTER...");
			try {
				System.in.read();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
		tiempo_inicial_ms = System.currentTimeMillis();
		// Contamos la calibracion
		doWork(cuentas_de_calibracion);
		tiempo_final_ms = System.currentTimeMillis();
		
		if (tiempo_final_ms < tiempo_inicial_ms)
		{
			System.out.println("Ha habido un overflow de tiempo");
			System.exit(1);
		}
		
		intervalo_ms = tiempo_final_ms - tiempo_inicial_ms;
		cuentas_por_ms = cuentas_de_calibracion/(intervalo_ms);
		
		if (interactivo)
		{
			System.out.println("Intervalo (ms): " + intervalo_ms + "  cuentas_de_calibracion: " + cuentas_de_calibracion);
			System.out.println("Cuentas por ms: " + cuentas_por_ms);
		}
		calibrado = true;
		
		return cuentas_por_ms;
	}

	// Default call to calibra
	public void calibra(boolean force)
	{
		calibra(force, true);
	}
	
	public void set_cuentas_calibracion(long cuentas_calibracion)
	{
		System.out.println("CARGA:  Calibrando a " + cuentas_calibracion);
		cuentas_por_ms = cuentas_calibracion;
		calibrado = true;
	}
	
	
	public void come_ms(long milisegundos)
	{
		if (!calibrado)
		{
			calibra(false, false);
		}
		doWork(milisegundos * cuentas_por_ms);
	}
	
	
	private void doWork(long cuentas)
	{
		double acum = 356.12;
		int n, k;
		
		for (n = 0; n < cuentas ; n++)
		{
			for (k = 0 ; k < 500 ; k++)
			{
				acum *= 3.12;
//				acum = 356.12;
			}
		}
	}
	
}
