package cpuclock;

public class Affinity {
	
	private int num_cpus;
	private long tid;
	private PidTid pidtid;
	
	private native int native_get_num_cpus();
	private native int native_set_affinity_mask(long tid, int mask);
	private native int native_get_affinity_mask(long tid);
	
	
	Affinity()
	{
		pidtid = new PidTid();
		
		tid = pidtid.get_tid();
		num_cpus = native_get_num_cpus();
		
	}
	
	public int set_affinity_mask(int mask)
	{
		int res = native_set_affinity_mask(this.tid,mask);
		return res;
	}
	
	public int get_affinity_mask()
	{
		int res = native_get_affinity_mask(this.tid);
		
		return res;
	}
	
	public int get_num_cpus()
	{
		return this.num_cpus;
	}
	
	static
	{
		System.loadLibrary("cpuclock");
	}
	

}
