package cpuclock;

import java.util.HashMap;

public class CpuClock {
	
	// Clock_id is defined as a 32 bit signed integer
    // see /usr/include/bits/typesizes.h
	private long thread_clock_id;
	private long process_clock_id;
	
	private native long get_thread_clock_id();
	private native long get_process_clock_id();
	
	private native void clock_get_time_tspec(long clock_id, long[] time_tspec);
	
	
	public CpuClock()
	{
		thread_clock_id = get_thread_clock_id();
		process_clock_id = get_process_clock_id();
	}
	
	public long get_thread_time_ms()
	{
		long result;
		
		long[] now_tspec = new long[2];
		clock_get_time_tspec(thread_clock_id, now_tspec);
		
		// Now[0] contains ns
		
		result = now_tspec[0] / 1000000 + now_tspec[1] * 1000;
		
		return result;
	}
	
	public long get_process_time_ms()
	{
		long result;
		
		long[] now_tspec = new long[2];
		clock_get_time_tspec(process_clock_id, now_tspec);
		
		// Now[0] contains ns
		
		result = now_tspec[0] / 1000000 + now_tspec[1] * 1000;
		
		return result;
	}
	

	
	static
	{
		//System.load("/usr/lib/jni/libcpuclock.so");
		System.loadLibrary("cpuclock");
		
	}
	
}
