// See man 7 feature_test_macros for the meaning of this define
// it is needed for the gettid syscall according to 
// LANG=C man 2 syscall
#define _GNU_SOURCE

#include <jni.h>

#include <unistd.h>
#include <sys/syscall.h>
#include <sys/types.h>



/*
 * Class:     cpuclock_PidTid
 * Method:    native_get_tid
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_cpuclock_PidTid_native_1get_1tid(JNIEnv *env, jobject obj)
{
    pid_t tid;
    
    // gettid() exists only as a prototype in glibc headers, but the implementation is
    // not included (yet).  The only way to call it is through the generic syscall() API which
    // talks directly to the kernel bypassing glibc.

    tid = syscall(SYS_gettid);

    return (jlong) tid;
}

/*
 * Class:     cpuclock_PidTid
 * Method:    native_get_pid
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_cpuclock_PidTid_native_1get_1pid(JNIEnv *env, jobject obj)
{
    pid_t pid;
   
    pid = getpid();

    return (jlong) pid;
}

