package tiposcomunes;

import clienteservicio.RandomGenerator;


public class FloatDistroData {
	
	
	public TipoDistribucion distribucion;
	public double nominal;
	public double rango;
	public String nombre;
	
	public FloatDistroData(String nombre)
	{
		this.nombre = nombre;
		distribucion = TipoDistribucion.CONSTANTE;
		nominal = 1.0;
		rango = 0.0;
				
	}
	
	public void asigna_valores(TipoDistribucion distribucion, double nominal, double rango)
	{
		this.distribucion = distribucion;
		this.nominal = nominal;
		this.rango = rango;
	}

	public void parsea_cmdarg(String cmdarg)
	{
		String values[] = cmdarg.split(",");
		
		if ( values[0].equals("UNI") )
		{
			distribucion = TipoDistribucion.UNIFORME;
		}
		else if ( values[0].equals("CTE") )
		{
			distribucion = TipoDistribucion.CONSTANTE;
		}
		else if ( values[0].equals("EXP") )
		{
			distribucion = TipoDistribucion.EXPONENCIAL;
		}
		else if ( values[0].equals("BIP") )
		{
			distribucion = TipoDistribucion.BIPOLAR;
		}

		// Got from http://www.devdaily.com/java/edu/qanda/pjqa00013.shtml
		nominal = Float.valueOf(values[1].trim()).floatValue();
		rango = Float.valueOf(values[2].trim()).floatValue();


	}
	
	public void printValue()
	{
		String linea = "Tipo: " + distribucion.toString() + "      Media: " + nominal  + "   Rango: " + rango;
		System.out.println(linea);
	}
	
	public float generaValorRandom()
	{
		float valor = 0.0F;
		
		switch (distribucion)
		{
		case CONSTANTE:
			valor = RandomGenerator.constantIAT(nominal);
			break;
		case EXPONENCIAL:
			valor = RandomGenerator.exponentialIAT(nominal);
			break;	
		case UNIFORME:
			valor = RandomGenerator.uniformIAT(nominal, rango);
			break;
		case BIPOLAR:
			valor = RandomGenerator.bipolarIAT(nominal, rango);
		}
		
		return valor;

	}
}
