package tiposcomunes;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

public class FloatDistroDataGUI 
{
	
	private Group swt_group = null;
	private Label distribucion_label = null;
	private Combo distribucion_combo = null;
	private Label nominal_label = null;
	private Text nominal_text = null;
	private Label rango_label = null;
	private Text rango_text = null;
	
	public FloatDistroDataGUI(Shell ventana, FloatDistroData dato)
	{
		
		swt_group = new Group(ventana, SWT.SHADOW_OUT);
		swt_group.setText(dato.nombre);
		swt_group.setLayout(new GridLayout(2, false));
		
		distribucion_label = new Label(swt_group, SWT.NONE);
		distribucion_label.setText("Distribucion:");
		distribucion_combo = new Combo(swt_group, SWT.NONE);
		
		GridData gridData_combo = new GridData();
		gridData_combo.widthHint = 140;  // Copied from ve GUI version
		distribucion_combo.setLayoutData(gridData_combo);
		
		for (TipoDistribucion distro : TipoDistribucion.values() )
		{
			distribucion_combo.add( distro.toString() );
		}
		
		nominal_label = new Label(swt_group, SWT.NONE);
		nominal_label.setText("Nominal:");
		nominal_text = new Text(swt_group, SWT.BORDER | SWT.LEFT);
		
		rango_label = new Label(swt_group, SWT.NONE);
		rango_label.setText("Rango:");
		rango_text = new Text(swt_group, SWT.BORDER | SWT.LEFT);
	}
	
	public void actualiza_valor(FloatDistroData dato)
	{
		distribucion_combo.select(dato.distribucion.ordinal() );
		nominal_text.setText(Double.toString(dato.nominal));
		rango_text.setText(Double.toString(dato.rango) );
	}
	
	public void lee_valor(FloatDistroData dato)
	{
		dato.distribucion = TipoDistribucion.valueOf(distribucion_combo.getText());
		dato.nominal = Double.parseDouble(nominal_text.getText() );
		dato.rango = Double.parseDouble(rango_text.getText() );
	}
	
	
}
