package tiposcomunes;

import clienteservicio.RandomGenerator;

public class IntDistroData {
	
	public TipoDistribucion distribucion;
	public int nominal;
	public int rango;
	public String nombre;
	
	public IntDistroData(String nombre)
	{
		this.nombre = nombre;
		
		// Valores por defecto
		distribucion = TipoDistribucion.CONSTANTE;
		nominal = 0;
		rango = 0;
	}
	
	public void asigna_valores(TipoDistribucion distribucion, int nominal, int rango)
	{
		this.distribucion = distribucion;
		this.nominal = nominal;
		this.rango = rango;
	}

	public void parsea_cmdarg(String cmdarg)
	{
		String values[] = cmdarg.split(",");
		
		if ( values[0].equals("UNI") )
		{
			distribucion = TipoDistribucion.UNIFORME;
		}
		else if ( values[0].equals("CTE") )
		{
			distribucion = TipoDistribucion.CONSTANTE;
		}
		else if ( values[0].equals("EXP") )
		{
			distribucion = TipoDistribucion.EXPONENCIAL;
		}
		else if ( values[0].equals("BIP") )
		{
			distribucion = TipoDistribucion.BIPOLAR;
		}

		// Got from http://www.devdaily.com/java/edu/qanda/pjqa00013.shtml
		nominal = Integer.valueOf(values[1].trim()).intValue();
		rango = Integer.valueOf(values[2].trim()).intValue();

	}
	
	public void printValue()
	{
		String linea = "Tipo: " + distribucion.toString() + "      Media: " + nominal  + "   Rango: " + rango;
		System.out.println(linea);
	}
	
	public long generaValorRandom()
	{
		long valor = 0;
		
		switch (distribucion)
		{
		case CONSTANTE:
			valor = RandomGenerator.constantSize(nominal);
			break;
		case EXPONENCIAL:
			valor = RandomGenerator.exponentialSize(nominal);
			break;	
		case UNIFORME:
			valor = RandomGenerator.uniformSize(nominal, rango);
			break;
		case BIPOLAR:
			valor = RandomGenerator.bipolarSize(nominal, rango);
		}
		
		return valor;

	}


}
